//+------------------------------------------------------------------+
//|                                    Schaff Trend Cycle for EA.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_minimum  -5
#property indicator_maximum 105

//
//
//
//
//

extern int STCPeriod    = 10;
extern int FastMAPeriod = 23;
extern int SlowMAPeriod = 50;

double schaff[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,schaff);
      SetIndexBuffer(1,trend);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

double workSch[][4];
#define _macd  0
#define _fastk 1
#define _fastd 2
#define _fasts 3

int start()
{
   int limit,i,r,counted_bars=IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(workSch,0)!=Bars) ArrayResize(workSch,Bars);

   //
   //
   //
   //
   //

   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      workSch[r][_macd] = iMA(NULL,0,FastMAPeriod,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowMAPeriod,0,MODE_EMA,PRICE_CLOSE,i);

      //
      //
      //
      //
      //
                     
         double lowMacd  = minValue(_macd,r);
         double highMacd = maxValue(_macd,r)-lowMacd;
            if (highMacd > 0)
                  workSch[r][_fastk] = 100*((workSch[r][_macd]-lowMacd)/highMacd);
            else  workSch[r][_fastk] = workSch[r-1][_fastk];
                  workSch[r][_fastd] = workSch[r-1][_fastd]+0.5*(workSch[r][_fastk]-workSch[r-1][_fastd]);
               
      //
      //
      //
      //
      //
                     
         double lowStoch  = minValue(_fastd,r);
         double highStoch = maxValue(_fastd,r)-lowStoch;
            if (highStoch > 0)
                  workSch[r][_fasts] = 100*((workSch[r][_fastd]-lowStoch)/highStoch);
            else  workSch[r][_fasts] = workSch[r-1][_fasts];
                  schaff[i]          = schaff[i+1]+0.5*(workSch[r][_fasts]-schaff[i+1]);
                  trend[i]           = trend[i+1];                  
                  if (schaff[i]>schaff[i+1]) trend[i] =  1;
                  if (schaff[i]<schaff[i+1]) trend[i] = -1;
   }   
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double minValue(int forValue,int shift)
{
   double minValue = workSch[shift][forValue];
            for (int i=1; i<STCPeriod && (shift-i)>=0; i++) minValue = MathMin(minValue,workSch[shift-i][forValue]);
   return(minValue);
}
double maxValue(int forValue,int shift)
{
   double maxValue = workSch[shift][forValue];
            for (int i=1; i<STCPeriod && (shift-i)>=0; i++) maxValue = MathMax(maxValue,workSch[shift-i][forValue]);
   return(maxValue);
}